function [I_A] = I_A(q, lstbta, lstth)
% q = [theta  phi  alpha]
% Returns the constrain coeficients A

global dth dph

rr = r(q(1), q(2));
rv = rr * ruv(q(1), q(2));

drv_dth = (r(q(1) + dth, q(2)) * ruv(q(1) + dth, q(2)) - rv) / dth;
thuv = drv_dth / sqrt(dot(drv_dth, drv_dth));

drv_dph = (r(q(1), q(2) + dph) * ruv(q(1), q(2) + dph) - rv) / dph;
phuv = drv_dph / sqrt(dot(drv_dph, drv_dph));

R = Rtr(q(1), q(2), q(3), lstbta, lstth);

ethuv = R * thuv;
ephuv = R * phuv;

dr_dth = (r(q(1) + dth, q(2)) - rr) / dth;
dr_dph = (r(q(1), q(2) + dph) - rr) / dph;

coef1 = sqrt(rr*rr + dr_dth*dr_dth);
coef2 = sqrt(rr*rr + dr_dph*dr_dph) * sin(q(1));

I_A(1, 1) = coef1 * ethuv(1);
I_A(1, 2) = coef1 * ethuv(2);

I_A(2, 1) = coef2 * ephuv(1);
I_A(2, 2) = coef2 * ephuv(2);

I_A(3, 1) = 0;
I_A(3, 2) = 0;

I_A(4, 1) = -1;
I_A(4, 2) = 0;

I_A(5, 1) = 0;
I_A(5, 2) = -1;

