function [L] = L(th, ph, alp, xp, yp, th1, ph1, alp1, xp1, yp1, lstbta, lstth)
% Returns the Lagrengian of the system

global I0 M g

R = Rtr(th, ph, alp, lstbta, lstth);

Rprime(1, 1) = cos(alp);
Rprime(1, 2) = -sin(alp);
Rprime(1, 3) = 0;

Rprime(2, 1) = sin(alp);
Rprime(2, 2) = cos(alp);
Rprime(2, 3) = 0;

Rprime(3, 1) = 0;
Rprime(3, 2) = 0;
Rprime(3, 3) = 1;

Rtot = Rprime * R;
Ic = Rtot' * I0 * Rtot;
cp = R*(r(th, ph) * ruv(th, ph));
dsp = -cp*cp';

dsp(1, 1) = dsp(1, 1) + 2*cp(1)*cp(1);
dsp(2, 2) = dsp(2, 2) + 2*cp(2)*cp(2);
dsp(3, 3) = dsp(3, 3) + 2*cp(3)*cp(3);

Ip = Ic + M*dsp;
omgp = omega(th, ph, alp, xp, yp, th1, ph1, alp1, xp1, yp1);
vcm = Vc(th, ph, alp, xp, yp, th1, ph1, alp1, xp1, yp1);

Hp = Ip*omgp;
Hc = Hp + M*cross(cp, vcm);
omgc = inv(Ic)*Hc;

T = 0.5 * (dot(omgc, Hc) + M*dot(vcm, vcm));
U = M * g * r(th, ph) * dot(ruv(th, ph), nuv(th, ph));

L = T - U;

