function [Rtr] = Rtr(th, ph, alp, lstbta, lstth)
% Returns the rotational transformation matrix 'R'
% alp = alpha
% lstbta = value of beta during the last iteration
% lstth = value of theta during the last iteration

err = .00001;

beta = bta(th, ph);
nuvc = nuv(th, ph);
ruvc = ruv(th, ph);


if beta == 0 & lstbta ~= 0
    beta = lstbta;
end

% When beta not equal to 0,
% To compute [R] such that [R]*nuvc = [0 0 -1]'
% And [R]*[Sin(th)Cos(ph) Sin(th)Sin(ph) Cos(th)]' = -[Sin(beta)Cos(alp) Sin(beta)Sin(alp) Cos(beta)]'

if beta ~= 0
    t = acos(-nuvc(3));
    p = atan(-nuvc(1)/nuvc(2));
    if abs(sin(t)*cos(p) - nuvc(2)) > err
        p = p + pi;
    end
    
    tmp1 = sin(t)*sin(beta);
    A = tmp1*cos(alp);
    B = tmp1*sin(alp);
    C = cos(t)*cos(beta) + cos(th);
    
    tmp2 = (-A) / (C-B);
    tmp3 = sqrt(A*A + B*B - C*C) / (C-B);
    s1 = 2 * atan(tmp2 + tmp3);
    s2 = 2 * atan(tmp2 - tmp3);
    chk = (cos(s1)*cos(p) - cos(t)*sin(p)*sin(s1))*(sin(th)*cos(ph)) + (cos(s1)*sin(p) + cos(t)*cos(p)*sin(s1))*(sin(th)*sin(ph)) + sin(s1)*sin(t)*cos(th) + sin(beta)*cos(alp);
    if abs(chk) > err
        s = s2;
    else
        s = s1;
    end
end


thta = th;
if th == 0 & lstth ~= 0
    thta = lstth;
end

% When beta equal to 0 and theta not 0,
% To compute [R] such that [R]*nuvc = [0 0 -1]'
% And [R]*[0 0 1]' = -[Sin(th)Cos(alp) Sin(th)Sin(alp) Cos(th)]'

if beta == 0 & thta ~= 0
    t = acos(-nuvc(3));
    p = atan(-nuvc(1)/nuvc(2));
    if abs(sin(t)*cos(p) - nuvc(2)) > err
        p = p + pi;
    end
    s = pi/2 - alp;
    if abs(sin(s)*sin(t) + sin(thta)*cos(alp)) > err
        s = s + pi;
    end
end


% When both beta and theta equal to 0,
% nuvc = [0 0 1]
% To compute [R] such that [R]*nuvc = [0 0 -1]'
% And [R]*[1 0 0]' = -[Cos(alp) Sin(alp) 0]'

if beta == 0 & thta == 0
    t = pi;
    p = pi/2 - ph;
    s = pi + p - alp;
end


% Forming [R]

Rtr(1, 1) = cos(s)*cos(p) - cos(t)*sin(p)*sin(s);
Rtr(1, 2) = cos(s)*sin(p) + cos(t)*cos(p)*sin(s);
Rtr(1, 3) = sin(s)*sin(t);

Rtr(2, 1) = -sin(s)*cos(p) - cos(t)*sin(p)*cos(s);
Rtr(2, 2) = -sin(s)*sin(p) + cos(t)*cos(p)*cos(s);
Rtr(2, 3) = cos(s)*sin(t);

Rtr(3, 1) = sin(t)*sin(p);
Rtr(3, 2) = -sin(t)*cos(p);
Rtr(3, 3) = cos(t);

%global dr
%dr,
%R,
%R*nuvc,
%R*[0 0 1]',
%-[sin(th)*cos(alp) sin(th)*sin(alp) cos(th)]',
%R*[sin(th)*cos(ph) sin(th)*sin(ph) cos(th)]',
%-[sin(beta)*cos(alp) sin(beta)*sin(alp) cos(beta)]',
%dot(R(:,2),R(:,2)),
%R(1,1)*R(1,2) + R(2,1)*R(2,2) +R(3,1)*R(3,2),
