function [Vc] = Vc(th, ph, alp, xp, yp, th1, ph1, alp1, xp1, yp1)
% Determines velocity of Centre of mass

global dth dph dalp dxp dyp

pcm = Pc(th, ph, alp, xp, yp);

Vc = ((Pc(th+dth, ph, alp, xp, yp) - pcm) / dth) * th1;
Vc = Vc + ((Pc(th, ph+dph, alp, xp, yp) - pcm) / dph) * ph1;
Vc = Vc + ((Pc(th, ph, alp+dalp, xp, yp) - pcm) / dalp) * alp1;
Vc = Vc + ((Pc(th, ph, alp, xp+dxp, yp) - pcm) / dxp) * xp1;
Vc = Vc + ((Pc(th, ph, alp, xp, yp+dyp) - pcm) / dyp) * yp1;
%Vc,

% ============================================


function [Pc] = Pc(th, ph, alp, xp, yp)

rr = r(th, ph);
beta = bta(th, ph);
tpc(1) = xp + rr*sin(beta)*cos(alp);
tpc(2) = yp + rr*sin(beta)*sin(alp);
tpc(3) = rr*cos(beta);

Pc = tpc';
