function [nuv] = nuv(th, ph)
% unit normal vector to the surface
% th = theta; ph = phi

global dth dph

rr = r(th, ph);
Sph = sin(ph);
Cph = cos(ph);
Sth = sin(th);
Cth = cos(th);

rv = 1;
thv = -((r(th+dth, ph) - rr)/dth) / rr;
phv = -((r(th, ph+dph) - rr)/dph) / (rr * Sth);

pro1 = rv*Sth + thv*Cth;

nv1(1) = pro1*Cph - phv*Sph;
nv1(2) = pro1*Sph + phv*Cph;
nv1(3) = rv*Cth - thv*Sth;

nuv = (nv1')/sqrt(dot(nv1, nv1));

%thv,
%phv,
%dot(nuv, nuv),
%nuv,
